<template>
  <div class="q-app">
    <h-login v-if="loaded && needAuth"></h-login>
    <router-view v-if="loaded"></router-view>
    <q-inner-loading :visible="!loaded" />
  </div>
</template>

<script>
  import HLogin from 'components/auth/login';
  import { mapActions, mapGetters } from 'vuex';

  const socialTokenRe = /access_token=([^&]+)/;
  const socialStateRe = /state=(facebook|google|irewind)([^&]*)/;

  export default {
    name: 'irwApp',
    data() {
      return {
        loaded: false,
      };
    },
    components: {
      HLogin,
    },
    computed: {
      ...mapGetters('auth', [
        'needAuth',
      ]),
    },
    methods: {
      ...mapActions('auth', [
        'login',
        'logout',
      ]),
    },
    mounted() {
      const { hash } = window ? window.location : { hash: '' };
      const token = socialTokenRe.exec(hash);
      const state = socialStateRe.exec(hash);

      if (token && state && state[1] !== 'irewind') {
        const credentials = {
          provider: state[1],
          token: token[1],
        };
        const handler = () => {
          if (window && state[2].length) {
            window.location = decodeURIComponent(state[2]);
          } else {
            this.loaded = true;
          }
        };
        this
          .login(credentials)
          .then(handler)
          .catch(handler);
      } else {
        const credentials = this.$q.localStorage.get.item('credentials');
        const handler = () => {
          this.loaded = true;
        };
        if (credentials) {
          this
            .login(JSON.parse(credentials))
            .then(handler)
            .catch(handler);
        } else {
          this.loaded = true;
        }
      }
    },
    beforeDestroy() {
      this.logout();
    },
  };
</script>
